import { world, system, BlockPermutation } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:ash_countdown', {
		onPlace: e => {
			const { block } = e;
			const {x,y,z} = block.location;
			const despawn = 'minecraft:air';
			system.runTimeout(() => {
				block.setPermutation(BlockPermutation.resolve(`${despawn}`))
			}, 600);
			system.runTimeout(() => {
				block.dimension.spawnParticle('pvz:ash_dissapear', { x: block.location.x + 0.5, y: block.location.y + 0.1, z: block.location.z + 0.5})
			}, 600);
		}
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('pvz:plant_deny', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const dirtSeeds = [
				"pvz:sunflower_seed",
				"pvz:peashooter_seed",
				"pvz:wallnut_seed",
				"pvz:potatomine_seed",
				"pvz:cabbage_seed",
				"pvz:bloomerang_seed",
				"pvz:iceberg_seed",
				"bonk_choy_seed",
				"pvz:repeater_seed",
				"pvz:twinflower_seed",
				"pvz:blockbuster_seed",
				"pvz:pumpkin_seed",
				"pvz:gloomshroom_seed",
				"pvz:snowpea_seed",
				"pvz:marigold_seed",
				"pvz:megagatling_seed",
				"pvz:birth_sunflower_seed",
				"pvz:doomshroom_seed",
				"pvz:fireboal_seed",
				"pvz:brick_pot"
			]
			
			if(selectedItem && selectedItem.typeId === 'pvz:gravebuster_seed') {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.grave"}]}');
			}
			else if(dirtSeeds.includes(selectedItem.typeId)) {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.ash"}]}');
			}
		}
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:light_countdown', {
		onPlace: e => {
			const { block } = e;
			const {x,y,z} = block.location;
			
			system.runTimeout(() => {
				block.dimension.spawnParticle('minecraft:basic_flame_particle', { x: block.location.x + 0.5, y: block.location.y + 0.1, z: block.location.z + 0.5})
			}, 5);
			system.runTimeout(() => {
				const lightness = block.permutation.getState("pvz:light_volume");
				const low = lightness +1;
				block.setPermutation(block.permutation.withState("pvz:light_volume", low));
			}, 7);
			system.runTimeout(() => {
				const lightness = block.permutation.getState("pvz:light_volume");
				const low = lightness +1;
				block.setPermutation(block.permutation.withState("pvz:light_volume", low));
			}, 9);
			system.runTimeout(() => {
				const lightness = block.permutation.getState("pvz:light_volume");
				const low = lightness +1;
				block.setPermutation(block.permutation.withState("pvz:light_volume", low));
			}, 11);
			system.runTimeout(() => {
				const lightness = block.permutation.getState("pvz:light_volume");
				const low = lightness +1;
				block.setPermutation(block.permutation.withState("pvz:light_volume", low));
			}, 13);
			system.runTimeout(() => {
				const lightness = block.permutation.getState("pvz:light_volume");
				const low = lightness +1;
				block.setPermutation(block.permutation.withState("pvz:light_volume", low));
			}, 15);
			system.runTimeout(() => {
				const lightness = block.permutation.getState("pvz:light_volume");
				const low = lightness +1;
				block.setPermutation(block.permutation.withState("pvz:light_volume", low));
			}, 17);
			system.runTimeout(() => {
				const low = 'minecraft:air';
				block.setPermutation(BlockPermutation.resolve(`${low}`))
			}, 20);
		}
	});
});