import { world, system, BlockPermutation, ItemStack, GameMode } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('pvz:chiseled_block', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const chisel = e.block.permutation.getState("pvz:texture");
			const chiseled = block.permutation.withState("pvz:texture", chisel +1);
			const unchiseled = block.permutation.withState("pvz:texture", chisel -9);
			const rechiseled = block.permutation.withState("pvz:texture", chisel -1);
			const reunchiseled = block.permutation.withState("pvz:texture", chisel +9);
            const inventory = player.getComponent('inventory').container
			
            if(!player.isSneaking && selectedItem && selectedItem.typeId === 'pvz:chisel' && block.permutation.getState("pvz:texture") < 9) {
                
                block.setPermutation(chiseled);
                player.playSound("block.grindstone.use");
				const durability = selectedItem.getComponent('durability');
				if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
					durability.damage++;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
					player.playSound("random.break");
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(!player.isSneaking && selectedItem && selectedItem.typeId === 'pvz:chisel' && block.permutation.getState("pvz:texture") === 9) {
                
                block.setPermutation(unchiseled);
                player.playSound("block.grindstone.use");
                const durability = selectedItem.getComponent('durability');
				if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
					durability.damage++;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
					player.playSound("random.break");
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
            }
			else if(!player.isSneaking && selectedItem && selectedItem.typeId === 'rev:chisel' && block.permutation.getState("pvz:texture") > 0) {
                
                block.setPermutation(rechiseled);
                player.playSound("block.grindstone.use");
				const durability = selectedItem.getComponent('durability');
				if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
					durability.damage++;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
					player.playSound("random.break");
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(!player.isSneaking && selectedItem && selectedItem.typeId === 'rev:chisel' && block.permutation.getState("pvz:texture") === 0) {
                
                block.setPermutation(reunchiseled);
                player.playSound("block.grindstone.use");
                const durability = selectedItem.getComponent('durability');
				if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
					durability.damage++;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
					player.playSound("random.break");
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:absorb_hability', {
		 onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const coarse = block.permutation.withState("pvz:absorbable", false);
			const fertile = block.permutation.withState("pvz:absorbable", true);
			const inventory = player.getComponent('inventory').container
			
            if(selectedItem && selectedItem.typeId === 'pvz:chisel' && block.permutation.getState("pvz:absorbable") === true) {
                
                block.setPermutation(coarse);
                player.playSound("block.beehive.shear");
				block.dimension.spawnParticle('pvz:cloud_particles', { x: block.location.x + 0.5, y: block.location.y + 0.5, z: block.location.z + 0.5})
				const steam = block.permutation.withState("pvz:family", 'none');
				block.setPermutation(steam);
				const durability = selectedItem.getComponent('durability');
				if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
					durability.damage++;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
					player.playSound("random.break");
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:chisel' && block.permutation.getState("pvz:absorbable") === false) {
                
                block.setPermutation(fertile);
                player.playSound("dig.grass");
				block.dimension.spawnParticle('minecraft:crop_growth_emitter', { x: block.location.x + 0.5, y: block.location.y + 0.5, z: block.location.z + 0.5})
				const durability = selectedItem.getComponent('durability');
				if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
					durability.damage++;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
					player.playSound("random.break");
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'rev:chisel' && block.permutation.getState("pvz:absorbable") === true) {
                
                block.setPermutation(coarse);
                player.playSound("block.beehive.shear");
				block.dimension.spawnParticle('pvz:cloud_particles', { x: block.location.x + 0.5, y: block.location.y + 0.5, z: block.location.z + 0.5})
				const steam = block.permutation.withState("pvz:family", 'none');
				block.setPermutation(steam);
				const durability = selectedItem.getComponent('durability');
				if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
					durability.damage++;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
					player.playSound("random.break");
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'rev:chisel' && block.permutation.getState("pvz:absorbable") === false) {
                
                block.setPermutation(fertile);
                player.playSound("dig.grass");
				block.dimension.spawnParticle('minecraft:crop_growth_emitter', { x: block.location.x + 0.5, y: block.location.y + 0.5, z: block.location.z + 0.5})
				const durability = selectedItem.getComponent('durability');
				if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
					durability.damage++;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
					player.playSound("random.break");
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
		}
	});
});