import { world, system, BlockPermutation, ItemStack, GameMode } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('pvz:music_play', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const music = e.block.permutation.getState("pvz:texture");
            const inventory = player.getComponent('inventory').container
			const musicDisc = [
				"pvz:grasswalk",
				"pvz:dryland",
				"pvz:bad_bash",
				"pvz:zombies_on_your_lawn",
				"pvz:zombie_time",
				"pvz:wabby_wabbo"
			]
			
            if(!player.isSneaking && selectedItem && selectedItem.typeId === 'pvz:grasswalk' && block.permutation.getState("pvz:texture") === 0) {
                
				const selected = block.permutation.withState("pvz:texture", music +1);
                block.setPermutation(selected);
                player.playSound("sound.grasswalk");
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
				return;
			}
			else if(!player.isSneaking && selectedItem && selectedItem.typeId === 'pvz:dryland' && block.permutation.getState("pvz:texture") === 0) {
                
				const selected = block.permutation.withState("pvz:texture", music +2);
                block.setPermutation(selected);
                player.playSound("sound.dryland");
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
				return;
			}
			else if(!player.isSneaking && selectedItem && selectedItem.typeId === 'pvz:bad_bash' && block.permutation.getState("pvz:texture") === 0) {
                
				const selected = block.permutation.withState("pvz:texture", music +3);
                block.setPermutation(selected);
                player.playSound("sound.bad_bash");
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
				return;
			}
			else if(!player.isSneaking && selectedItem && selectedItem.typeId === 'pvz:zombies_on_your_lawn' && block.permutation.getState("pvz:texture") === 0) {
                
				const selected = block.permutation.withState("pvz:texture", music +4);
                block.setPermutation(selected);
                player.playSound("sound.zoyl");
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
				return;
			}
			else if(!player.isSneaking && selectedItem && selectedItem.typeId === 'pvz:zombie_time' && block.permutation.getState("pvz:texture") === 0) {
                
				const selected = block.permutation.withState("pvz:texture", music +5);
                block.setPermutation(selected);
                player.playSound("sound.zombie_time");
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
				return;
			}
			else if(!player.isSneaking && selectedItem && selectedItem.typeId === 'pvz:wabby_wabbo' && block.permutation.getState("pvz:texture") === 0) {
                
				const selected = block.permutation.withState("pvz:texture", music +6);
                block.setPermutation(selected);
                player.playSound("sound.wabby_wabbo");
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
				return;
			}
			else if(block.permutation.getState("pvz:texture") > 0) {
			
				player.playSound("random.pop");
				if (block.permutation.getState("pvz:texture") === 1) {
					const spawnItem = new ItemStack("pvz:grasswalk");
					const stop = block.permutation.withState("pvz:texture", music -1);
					block.dimension.spawnItem(spawnItem, block.center());
					player.runCommand('stopsound @a[r=30] sound.grasswalk');
					block.setPermutation(stop);
				}
				else if (block.permutation.getState("pvz:texture") === 2) {
					const spawnItem = new ItemStack("pvz:dryland");
					const stop = block.permutation.withState("pvz:texture", music -2);
					block.dimension.spawnItem(spawnItem, block.center());
					player.runCommand('stopsound @a[r=30] sound.dryland');
					block.setPermutation(stop);
				}
				else if (block.permutation.getState("pvz:texture") === 3) {
					const spawnItem = new ItemStack("pvz:bad_bash");
					const stop = block.permutation.withState("pvz:texture", music -3);
					block.dimension.spawnItem(spawnItem, block.center());
					player.runCommand('stopsound @a[r=30] sound.bad_bash');
					block.setPermutation(stop);
				}
				else if (block.permutation.getState("pvz:texture") === 4) {
					const spawnItem = new ItemStack("pvz:zombies_on_your_lawn");
					const stop = block.permutation.withState("pvz:texture", music -4);
					block.dimension.spawnItem(spawnItem, block.center());
					player.runCommand('stopsound @a[r=30] sound.zoyl');
					block.setPermutation(stop);
				}
				else if (block.permutation.getState("pvz:texture") === 5) {
					const spawnItem = new ItemStack("pvz:zombie_time");
					const stop = block.permutation.withState("pvz:texture", music -5);
					block.dimension.spawnItem(spawnItem, block.center());
					player.runCommand('stopsound @a[r=30] sound.zombie_time');
					block.setPermutation(stop);
				}
				else if (block.permutation.getState("pvz:texture") === 6) {
					const spawnItem = new ItemStack("pvz:wabby_wabbo");
					const stop = block.permutation.withState("pvz:texture", music -6);
					block.dimension.spawnItem(spawnItem, block.center());
					player.runCommand('stopsound @a[r=30] sound.wabby_wabbo');
					block.setPermutation(stop);
				}
			}
		}
	});
});