import { world, Player, ItemComponentTypes, ItemStack, GameMode } from '@minecraft/server'

world.afterEvents.entityHitEntity.subscribe((event) => {
	const source = event.damagingEntity
	const entity = event.hitEntity
	const item = source.getComponent('equippable');
	const weapon= item.getEquipment('Mainhand');
	
	if (weapon.typeId === 'pvz:great_torch' && weapon.typeId != undefined) {
		source.runCommand('effect @s fire_resistance 1 0 true');
		source.playSound("mob.blaze.shoot");
		entity.runCommand('setblock ~~~ fire');
		const durability = weapon.getComponent('durability');
		
		if (source?.typeId === 'minecraft:player' && !source.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
			weapon.setEquipment('Mainhand', weapon);
		}
		else if (source?.typeId === 'minecraft:player' && !source.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
			durability.damage--;
			source.runCommand('stopsound @s mob.blaze.shoot');
			source.playSound("extinguish.candle");
			weapon.setEquipment('Mainhand', new ItemStack('pvz:great_torch_off', 1));
		}
	}
	else if (weapon.typeId === 'firei:great_torch' && weapon.typeId != undefined) {
		source.runCommand('effect @s fire_resistance 1 0 true');
		source.playSound("mob.blaze.shoot");
		source.runCommand('tag @s add unscorched');
		entity.runCommand('summon anim:fire_i');
		const durability = weapon.getComponent('durability');
		
		if (source?.typeId === 'minecraft:player' && !source.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
			weapon.setEquipment('Mainhand', weapon);
		}
		else if (source?.typeId === 'minecraft:player' && !source.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
			durability.damage--;
			source.runCommand('stopsound @s mob.blaze.shoot');
			source.playSound("extinguish.candle");
			weapon.setEquipment('Mainhand', new ItemStack('pvz:great_torch_off', 1));
		}
	}
	else if (weapon.typeId === 'fireii:great_torch' && weapon.typeId != undefined) {
		source.runCommand('effect @s fire_resistance 1 0 true');
		source.playSound("mob.blaze.shoot");
		source.runCommand('tag @s add unscorched');
		entity.runCommand('summon anim:fire_ii');
		const durability = weapon.getComponent('durability');
		
		if (source?.typeId === 'minecraft:player' && !source.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
			weapon.setEquipment('Mainhand', weapon);
		}
		else if (source?.typeId === 'minecraft:player' && !source.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
			durability.damage--;
			source.runCommand('stopsound @s mob.blaze.shoot');
			source.playSound("extinguish.candle");
			weapon.setEquipment('Mainhand', new ItemStack('pvz:great_torch_off', 1));
		}
	}
	else if (weapon.typeId === 'fireiii:great_torch' && weapon.typeId != undefined) {
		source.runCommand('effect @s fire_resistance 1 0 true');
		source.playSound("mob.blaze.shoot");
		source.runCommand('tag @s add unscorched');
		entity.runCommand('summon anim:fire_iii');
		const durability = weapon.getComponent('durability');
		
		if (source?.typeId === 'minecraft:player' && !source.matches({ gameMode: GameMode.creative}) && durability && durability.damage < durability.maxDurability) {
			weapon.setEquipment('Mainhand', weapon);
		}
		else if (source?.typeId === 'minecraft:player' && !source.matches({ gameMode: GameMode.creative}) && durability && durability.damage >= durability.maxDurability) {
			durability.damage--;
			source.runCommand('stopsound @s mob.blaze.shoot');
			source.playSound("extinguish.candle");
			weapon.setEquipment('Mainhand', new ItemStack('pvz:great_torch_off', 1));
		}
	}
});