import { world, system, BlockPermutation, ItemStack, GameMode } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:mini_pets', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const despawn = 'minecraft:air';
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			
			if(selectedItem && selectedItem.typeId === 'pvz:sunflower_seed') {
				
				block.dimension.spawnEntity('pvz:mini_sunflower', { x: block.location.x +0.5, y: block.location.y +0, z: block.location.z +0 });
				block.setPermutation(BlockPermutation.resolve(`${despawn}`))
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:peashooter_seed') {
				
				block.dimension.spawnEntity('pvz:mini_peashooter', { x: block.location.x +0.5, y: block.location.y +0, z: block.location.z +0.5 });
				block.setPermutation(BlockPermutation.resolve(`${despawn}`))
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
		}
	});
});