import { world, system, BlockPermutation } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:plantable_pot', {
		onTick(e) {
			const { block } = e;
			const {x,y,z} = block.location;
			const unplantable = block.permutation.withState("pvz:plantable", false);
			const plantable = block.permutation.withState("pvz:plantable", true);
			block.setPermutation(plantable);
			const systemRun = system.run(() => {
				const entities = block.dimension.getEntities({
					location:{ x: block.location.x +0.5, y: block.location.y +0.5, z: block.location.z +0.5 },
					maxDistance: 0.75,
					families: ["plant"],
				});
				for(const entity of entities) {
					if(entity.matches({ families: ["plant"] })) {
						block.setPermutation(unplantable);
					}
					else if(!entity.matches({ families: ["plant"] })) {
					}
				};
			});
		},
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:vineable_pot', {
		onTick(e) {
			const { block } = e;
			const {x,y,z} = block.location;
			const unvineable = block.permutation.withState("pvz:vineable", false);
			const unplantable = block.permutation.withState("pvz:plantable", false);
			const vineable = block.permutation.withState("pvz:vineable", true);
			block.setPermutation(vineable);
			const systemRun = system.run(() => {
				const entities = block.dimension.getEntities({
					location:{ x: block.location.x +0.5, y: block.location.y +0.5, z: block.location.z +0.5 },
					maxDistance: 0.75,
					families: ["vine"],
				});
				for(const entity of entities) {
					if(entity.matches({ families: ["vine"] })) {
						block.setPermutation(unvineable);
					}
					else if(entity.matches({ families: ["vine"] }) && block.permutation.getState("pvz:plantable") === false) {
						block.setPermutation(unvineable);
						block.setPermutation(unplantable);
					}
				};
			});
		},
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:plantable_slot', {
		onTick(e) {
			const { block } = e;
			const {x,y,z} = block.location;
			const unplantable = block.permutation.withState("pvz:plantable", false);
			const plantable = block.permutation.withState("pvz:plantable", true);
			block.setPermutation(plantable);
			const systemRun = system.run(() => {
				const entities = block.dimension.getEntities({
					location:{ x: block.location.x +0.5, y: block.location.y +1.5, z: block.location.z +0.5 },
					maxDistance: 0.75,
					families: ["plant"],
				});
				for(const entity of entities) {
					if(entity.matches({ families: ["plant"] })) {
						block.setPermutation(unplantable);
					}
					else if(!entity.matches({ families: ["plant"] })) {
					}
				};
			});
		},
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:vineable_slot', {
		onTick(e) {
			const { block } = e;
			const {x,y,z} = block.location;
			const unvineable = block.permutation.withState("pvz:vineable", false);
			const unplantable = block.permutation.withState("pvz:plantable", false);
			const vineable = block.permutation.withState("pvz:vineable", true);
			block.setPermutation(vineable);
			const systemRun = system.run(() => {
				const entities = block.dimension.getEntities({
					location:{ x: block.location.x +0.5, y: block.location.y +1.5, z: block.location.z +0.5 },
					maxDistance: 0.75,
					families: ["vine"],
				});
				for(const entity of entities) {
					if(entity.matches({ families: ["vine"] })) {
						block.setPermutation(unvineable);
					}
					else if(entity.matches({ families: ["vine"] }) && block.permutation.getState("pvz:plantable") === false) {
						block.setPermutation(unvineable);
						block.setPermutation(unplantable);
					}
				};
			});
		},
	});
});