import { world, system, BlockPermutation, ItemStack, GameMode } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:plant_placer', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const unplantable = block.permutation.withState("pvz:plantable", false);
			
			if(selectedItem && selectedItem.typeId === 'pvz:sunflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:sunflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:peashooter_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:peashooter', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:wallnut_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:wallnut', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:cabbage_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:cabbage_pult', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:potatomine_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:restpotato', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:bloomerang_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:bloomerang', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:iceberg_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:lettuce_iceberg', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:bonk_choy_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:bonk_choy', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:repeater_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:repeater', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:twinflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:twinflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:gravebuster_seed') {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.grave"}]}');
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snowpea_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snowpea', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:blockbuster_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:blockbuster', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:gloomshroom_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:gloomshroom', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:pumpkin_seed' && block.permutation.getState("pvz:vineable") === true) {
				
				block.dimension.spawnEntity('pvz:pumpkin', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:birth_sunflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:birth_sunflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:megagatling_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:megagatling', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:doomshroom_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:doomshroom', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:fireboal_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:fireboal', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:marigold_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:marigold', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:kernel_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:kernel_pult', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:cornie_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:caramel_corn', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:camera_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:camera_plant', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snake_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snake_grass', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snake_clone_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snake_grass_clone', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
		}
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:cloud_placer', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const unplantable = block.permutation.withState("pvz:plantable", false);
			
			if(selectedItem && selectedItem.typeId === 'pvz:sunflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:sunflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:peashooter_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:peashooter', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:wallnut_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:wallnut', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:cabbage_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:cabbage_pult', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:potatomine_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:restpotato', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:bloomerang_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:bloomerang', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:iceberg_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:lettuce_iceberg', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:bonk_choy_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:bonk_choy', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:repeater_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:repeater', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:twinflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:twinflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:gravebuster_seed') {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.grave"}]}');
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snowpea_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snowpea', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:blockbuster_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:blockbuster', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:gloomshroom_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:gloomshroom', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:pumpkin_seed' && block.permutation.getState("pvz:vineable") === true) {
				
				block.dimension.spawnEntity('pvz:pumpkin', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:birth_sunflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:birth_sunflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:megagatling_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:megagatling', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:doomshroom_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:doomshroom', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:fireboal_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:fireboal', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:marigold_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:marigold', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:kernel_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:kernel_pult', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:cornie_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:caramel_corn', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:camera_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:camera_plant', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snake_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snake_grass', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snake_clone_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snake_grass_clone', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
		}
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('pvz:pot_placer', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const dirtSeeds = [
				"pvz:sunflower_seed",
				"pvz:peashooter_seed",
				"pvz:wallnut_seed",
				"pvz:potatomine_seed",
				"pvz:cabbage_seed",
				"pvz:bloomerang_seed",
				"pvz:iceberg_seed",
				"bonk_choy_seed",
				"pvz:repeater_seed",
				"pvz:twinflower_seed",
				"pvz:blockbuster_seed",
				"pvz:pumpkin_seed",
				"pvz:gloomshroom_seed",
				"pvz:snowpea_seed",
				"pvz:marigold_seed",
				"pvz:megagatling_seed",
				"pvz:birth_sunflower_seed",
				"pvz:doomshroom_seed",
				"pvz:fireboal_seed",
				"pvz:kernel_seed",
				"pvz:cornie_seed",
				"pvz:camera_seed"
			]
			
			if(selectedItem && selectedItem.typeId === 'pvz:brick_pot') {
				
				block.above().setType('pvz:brick_pot');
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:gravebuster_seed') {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.grave"}]}');
			}
			else if(dirtSeeds.includes(selectedItem.typeId)) {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.dirt"}]}');
			}
		}
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('pvz:sprout_placer', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const unplantable = block.permutation.withState("pvz:plantable", false);
			const dirtSeeds = [
				"pvz:sunflower_seed",
				"pvz:peashooter_seed",
				"pvz:wallnut_seed",
				"pvz:potatomine_seed",
				"pvz:cabbage_seed",
				"pvz:bloomerang_seed",
				"pvz:iceberg_seed",
				"bonk_choy_seed",
				"pvz:repeater_seed",
				"pvz:twinflower_seed",
				"pvz:blockbuster_seed",
				"pvz:pumpkin_seed",
				"pvz:gloomshroom_seed",
				"pvz:snowpea_seed",
				"pvz:marigold_seed",
				"pvz:megagatling_seed",
				"pvz:birth_sunflower_seed",
				"pvz:doomshroom_seed",
				"pvz:fireboal_seed",
				"pvz:kernel_seed",
				"pvz:cornie_seed",
				"pvz:camera_seed"
			]
			
			if(selectedItem && selectedItem.typeId === 'pvz:brick_pot') {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.pot.pot"}]}');
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:gravebuster_seed') {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.grave"}]}');
			}
			else if(dirtSeeds.includes(selectedItem.typeId)) {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.dirt"}]}');
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:sprout_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:sprout<minecraft:wood_class>', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
		}
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('pvz:pool_placer', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const unplantable = block.permutation.withState("pvz:plantable", false);
			const dirtSeeds = [
				"pvz:sprout_seed",
				"pvz:sunflower_seed",
				"pvz:peashooter_seed",
				"pvz:wallnut_seed",
				"pvz:potatomine_seed",
				"pvz:cabbage_seed",
				"pvz:bloomerang_seed",
				"pvz:iceberg_seed",
				"pvz:bonk_choy_seed",
				"pvz:repeater_seed",
				"pvz:twinflower_seed",
				"pvz:blockbuster_seed",
				"pvz:pumpkin_seed",
				"pvz:gloomshroom_seed",
				"pvz:snowpea_seed",
				"pvz:marigold_seed",
				"pvz:megagatling_seed",
				"pvz:birth_sunflower_seed",
				"pvz:doomshroom_seed",
				"pvz:fireboal_seed",
				"pvz:kernel_seed",
				"pvz:cornie_seed",
				"pvz:camera_seed",
				"pvz:brick_pot"
			]
			
			if(selectedItem && selectedItem.typeId === 'pvz:gravebuster_seed') {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.grave"}]}');
			}
			else if(dirtSeeds.includes(selectedItem.typeId)) {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.dirt"}]}');
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:seashroom_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:seashroom', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snake_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snake_grass', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snake_clone_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snake_grass_clone', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
		}
	});
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.blockComponentRegistry.registerCustomComponent('pvz:universal_plant_placer', {
        onPlayerInteract(e) {
            const { player, block } = e;
            const {x,y,z} = block.location;
			const equipment = player.getComponent('equippable');
			const selectedItem = equipment.getEquipment('Mainhand');
			const unplantable = block.permutation.withState("pvz:plantable", false);
			
			if(selectedItem && selectedItem.typeId === 'pvz:sunflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:sunflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:peashooter_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:peashooter', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:wallnut_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:wallnut', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:cabbage_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:cabbage_pult', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:potatomine_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:restpotato', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:bloomerang_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:bloomerang', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:iceberg_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:lettuce_iceberg', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:bonk_choy_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:bonk_choy', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:repeater_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:repeater', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:twinflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:twinflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:gravebuster_seed') {
				
				player.runCommand('titleraw @p actionbar {"rawtext":[{"translate":"action.plant.grave"}]}');
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snowpea_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snowpea', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:blockbuster_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:blockbuster', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:gloomshroom_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:gloomshroom', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:pumpkin_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:pumpkin', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:birth_sunflower_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:birth_sunflower', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:megagatling_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:megagatling', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:doomshroom_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:doomshroom', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:fireboal_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:fireboal', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:marigold_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:marigold', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:kernel_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:kernel_pult', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:cornie_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:caramel_corn', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:camera_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:camera_plant', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snake_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snake_grass', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:snake_clone_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:snake_grass_clone', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
			else if(selectedItem && selectedItem.typeId === 'pvz:sprout_seed' && block.permutation.getState("pvz:plantable") === true) {
				
				block.dimension.spawnEntity('pvz:sprout<minecraft:gold_class>', { x: block.location.x +0.5, y: block.location.y +1, z: block.location.z +0.5 });
				block.setPermutation(unplantable);
				
				if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount > 1) {
					selectedItem.amount -= 1;
					equipment.setEquipment('Mainhand', selectedItem);
				}
				else if (!player.matches({ gameMode: GameMode.creative}) && selectedItem.amount === 1) {
					equipment.setEquipment('Mainhand', new ItemStack('minecraft:air', 1));
				}
			}
		}
	});
});